function Game() {
    this.$recordsPopup = $("#records_popup");
    this.$popupPointsParagraph = $("#points_paragraph");
    this.$popupPlayAgainBtn = $("#records_popup_btn");
    this.$popupPlayAgainBtn.click(function(e) {
        objects.game.$recordsPopup.addClass(domElements.invisibleClassName);
        objects.game.startNewGame();
        utils.turnOnScreen(domElements.$gameScreen);
    });

    this.$pointsSpan = $("#points_span");
    this.tick = this.timer = this.clearTimeout = this.pauseTimeout = undefined;
    this.background = undefined;
    this.space = this.player = this.points = undefined;

    this.setView();
}

Game.prototype.setView = function() {
    this.background = new paper.Path.Rectangle(new paper.Point(0, 0), new paper.Size(constants.GAME_WIDTH, constants.GAME_HEIGHT));
//    this.background.fillColor = settings.BACKGROUND_COLOR;
    this.space = new Space();
    this.player = new Player();
}

Game.prototype.setClickPoint = function(clickPoint) {
    if(typeof (this.player.targetAngle) != "undefined") {
        this.player.setFlyAway();
        return;
    }
    if(typeof (this.player.activePlanet) == "undefined") return;
//    if(typeof (this.player.activePlanet.img) == "undefined") return;
//    if(this.player.img.hitTest(clickPoint) != null || this.player.activePlanet.img.hitTest(clickPoint) != null
//            || this.player.isFlying) return;
    var deltaX = clickPoint.x - this.player.activePlanet.img.position.x;
    var deltaY = clickPoint.y - this.player.activePlanet.img.position.y;
    var degrees = (Math.atan2(deltaY, deltaX) * 180 / Math.PI);
    this.player.setFlightDegree(degrees);
}

Game.prototype.startNewGame = function() {
    this.points = 0;
    this.setTexts();
    this.space.setToStart();
    this.player.setToStart();
    this.tick = 0;
    this.timer = window.setInterval(function() {
        objects.game.onFrame();
    }, constants.MILISECONDS_FOR_FRAME);
}

Game.prototype.pauseGame = function(pauseMilliseconds) {
    if(typeof (this.timer) == "undefined") return;
    window.clearInterval(this.timer);
    this.timer = undefined;
    this.pauseTimeout = window.setTimeout(function(){objects.game.resumeGame();}, pauseMilliseconds);
}

Game.prototype.resumeGame = function() {
    window.clearTimeout(this.pauseTimeout);
    this.pauseTimeout = undefined;
    this.timer = window.setInterval(function() {objects.game.onFrame();}, constants.MILISECONDS_FOR_FRAME);
}

Game.prototype.onFrame = function() {
    this.tick += constants.MILISECONDS_FOR_FRAME;
    if(this.tick % (settings.SECONDS_FOR_LEVEL_UP * 1000) == 0) {
        this.space.neededPlanets += settings.PLUS_PLANETS_PER_LEVEL;
        this.player.pointsToPlus += settings.PLUS_POINTS_PER_FLIGHT_FRAME;
        this.space.nova.setNextLevel();
    }

    this.player.onFrame();
    this.space.onFrame();

	paper.view.draw();
}

Game.prototype.testEnd = function() {
    this.endGame();
}


Game.prototype.endGame = function() {
    window.clearInterval(this.timer);
    this.timer = undefined;
    this.clearTimer = window.setTimeout(function() {
        objects.game.removeGameObjects();
    }, constants.MILISECONDS_FOR_FRAME);
}

Game.prototype.removeGameObjects = function() {
    window.clearTimeout(this.clearTimer);
    this.clearTimer = undefined;

    variables.currentScore = this.points;
    this.space.clear();

    if(settings.RECORDS_ENABLED) {
        objects.records.setNewRecords();
        utils.turnOnScreen(domElements.$recordScreen);
    }else {
        this.$recordsPopup.removeClass(domElements.invisibleClassName);
        this.$popupPointsParagraph.text(this.points);
        //RECORDS
    }
}

Game.prototype.setTexts = function() {
    this.$pointsSpan.text(this.points);
}