function Nova() {
    this.height = this.speed = this.mapImg = this.img = undefined;

}

Nova.prototype.setToStart = function() {
    this.speed = settings.START_NOVA_SPEED;
    this.height = 0;
}

Nova.prototype.setNextLevel = function() {
    this.speed += settings.PLUS_LEVEL_NOVA_SPEED;
    if(this.speed > settings.MAX_NOVA_SPEED) this.speed = settings.MAX_NOVA_SPEED;
}

Nova.prototype.onFrame = function() {
    this.height += this.speed;
    if(typeof (objects.game.player.yDiference) != "undefined") {
        this.height -= objects.game.player.yDiference;
        if(this.height < 0) this.height = 0;
    }
    this.redrawObjects();
    if(this.height > settings.ACTIVE_PLANETS_FIELD_SIZE + settings.ACTIVE_PLANETS_FIELD_SIZE / 2 +
            (constants.GAME_HEIGHT / 2 - objects.game.player.img.position.y)) {
        objects.game.testEnd();
    }
}

Nova.prototype.redrawObjects = function() {
    this.clear();
    this.mapImg = new paper.Path.Rectangle(new paper.Point(constants.GAME_WIDTH - settings.ACTIVE_PLANETS_FIELD_SIZE / 10,
            constants.GAME_HEIGHT - this.height / 10),
            new paper.Size(settings.ACTIVE_PLANETS_FIELD_SIZE / 10, this.height / 10));
    this.mapImg.fillColor = settings.NOVA_COLOR;
    this.mapImg.opacity = 0.5;
    this.mapImg.moveAbove(objects.game.space.map.backRect);
    this.mapImg.moveAbove(objects.game.space.map.viewRect);

//    console.log(this.height + "   " + (settings.ACTIVE_PLANETS_FIELD_SIZE + settings.ACTIVE_PLANETS_FIELD_SIZE / 2 - settings.GAME_HEIGHT / 2));
    if(this.height > settings.ACTIVE_PLANETS_FIELD_SIZE + settings.ACTIVE_PLANETS_FIELD_SIZE / 2 - settings.GAME_HEIGHT / 2) {
        var heightDifference = this.height - (settings.ACTIVE_PLANETS_FIELD_SIZE + settings.ACTIVE_PLANETS_FIELD_SIZE / 2 - settings.GAME_HEIGHT / 2);
        this.img = new paper.Path.Rectangle(new paper.Point(0, (constants.GAME_HEIGHT - heightDifference)+100), new paper.Size(constants.GAME_WIDTH, window.innerHeight*5));
        this.img.fillColor = settings.NOVA_COLOR;
        this.img.opacity = 0.5;
    }
}

Nova.prototype.clear = function() {
    if(typeof (this.mapImg) != "undefined") {
        this.mapImg.remove();
        this.mapImg = undefined;
    }
    if(typeof (this.img) != "undefined") {
        this.img.remove();
        this.img = undefined;
    }
}