function Planet() {
    this.mapImg = this.img = this.size = undefined;


    this.setView();
}

Planet.prototype.setView = function() {
    this.size = Math.round(Math.random() * (settings.MAX_PLANET_SIZE - settings.MIN_PLANET_SIZE)) + settings.MIN_PLANET_SIZE;
    this.img = new paper.Raster(variables.planetsImages[Math.round(Math.random() * (variables.planetsImages.length - 1))]);
    this.img.rotate(Math.round(Math.random() * 360));
    this.img.size = new paper.Size(this.size, this.size);
    this.img.moveBelow(objects.game.player.img);

    this.mapImg = new paper.Path.Circle(new paper.Point(0, 0), this.size / 40);
    this.mapImg.fillColor = settings.MAP_PLANETS_FILL_COLOR;
}

Planet.prototype.setToPoint = function(point) {
    this.img.position = point;

    this.mapImg.position = new paper.Point(point.x / 20 + constants.GAME_WIDTH - settings.ACTIVE_PLANETS_FIELD_SIZE / 10 / 2 - constants.GAME_WIDTH / 10 / 4,
            point.y /20 + constants.GAME_HEIGHT - settings.ACTIVE_PLANETS_FIELD_SIZE / 10 * 2 + settings.ACTIVE_PLANETS_FIELD_SIZE / 10 / 2 - constants.GAME_HEIGHT / 10 / 4);
}

Planet.prototype.clear = function() {
    if(typeof (this.img) == "undefined") return;
    this.img.remove();
    this.img = undefined;

    if(typeof (this.mapImg) == "undefined") return;
    this.mapImg.remove();
    this.mapImg = undefined;
}